///////////////////////////////////////////////////////////////////////////////
//
//   memory allocation functions by Hansung Kim
//   
//   updated 2005. 2. 9
//
////////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct UnsignedRGB{
    unsigned char r;    unsigned char g;	unsigned char b;
} UnsignedRGB;

unsigned char **Allo2UC(int row, int col);
int **Allo2Int(int row, int col);
double **Allo2Double(int row, int col);
float **Allo2Float(int row, int col);
short **Allo2Short(int row, int col);	
int ***Allo3Int(int z, int row, int col);
short ***Allo3Short(int z, int row, int col);
unsigned char*** Allo3UC(int z, int row, int col);
UnsignedRGB **Allo2RGB(int row, int col);
void Deallo2UC(unsigned char **img, int row);
void Deallo2Double(double **img, int row);
void Deallo2Float(float **img, int row);
void Deallo2Short(short **img, int row);
void Deallo2Int(int **img, int row);
void Deallo3Int(int ***img, int z, int row);
void Deallo3Short(short ***img, int z, int row);	
void Deallo3UC(unsigned char ***img, int z, int row);
void Deallo2RGB(UnsignedRGB **img, int row);

unsigned char** Allo2UC(int row, int col)
{
	int i;
	unsigned char **m2;

	m2 = new unsigned char*[row];

	for(i = 0 ; i < row; i++)
		m2[i] = new unsigned char[col];

	return m2;

}


int **Allo2Int(int row, int col)
{
	int i,**m2;
	
	m2 = new int*[row];

	for(i = 0 ; i < row; i++)
		m2[i] = new int[col];

	return m2;
}

double **Allo2Double(int row, int col)
{
	int i;
	double **m2;

	m2 = new double*[row];

	for(i = 0 ; i < row; i++)
		m2[i] = new double[col];

	return m2;	
}

float **Allo2Float(int row, int col)
{
	int i;
	float **m2;

	m2 = new float*[row];
	for(i = 0 ; i < row; i++)
		m2[i] = new float[col];
	
	return m2;	
}

short **Allo2Short(int row, int col)
{
	int i;
	short **m2;

	m2 = new short*[row];
	for(i = 0 ; i < row; i++)
		m2[i] = new short[col];
	
	return m2;	
}

int ***Allo3Int(int z, int row, int col)
{
	int i,j;
	int ***m2;
	
	m2 = new int**[z];
	for(i = 0 ; i < z; i++)
	{
		m2[i] = new int*[row];
		for(j=0 ; j<row ; j++)
			m2[i][j] = new int[col];
	}

	return m2;
}

short ***Allo3Short(int z, int row, int col)
{
	int i,j;
	short ***m2;
	
	m2 = new short**[z];
	for(i = 0 ; i < z; i++)
	{
		m2[i] = new short*[row];
		for(j=0 ; j<row ; j++)
			m2[i][j] = new short[col];
	}
	return m2;
}

unsigned char*** Allo3UC(int z, int row, int col)
{
	int i,j;
	unsigned char ***m2;
	
	m2 = new unsigned char **[z];
	for(i = 0 ; i < z; i++)
	{
		m2[i] = new unsigned char *[row];
		for(j=0 ; j<row ; j++)
			m2[i][j] = new unsigned char [col];
	}
	return m2;
}

UnsignedRGB **Allo2RGB(int row, int col)
{
	int i;
	UnsignedRGB **m2;

	m2 = new UnsignedRGB*[row];
	for(i = 0 ; i < row; i++)
		m2[i] = new UnsignedRGB[col];
	
	return m2;	

}



void Deallo2UC(unsigned char **img, int row)
{
	int i;
	for (i = 0; i < row;  i++)
		delete[] img[i];
	delete[] img;
}

void Deallo2Double(double **img, int row)
{
	int i;
	for (i = 0; i < row;  i++)
		delete[] img[i];
	delete[] img;
}

void Deallo2Float(float **img, int row)
{
	int i;
	for (i = 0; i < row;  i++)
		delete[] img[i];
	delete[] img;
}

void Deallo2Short(short **img, int row)
{
	int i;
	for (i = 0; i < row;  i++)
		delete[] img[i];
	delete[] img;
}

void Deallo2Int(int **img, int row)
{
	int i;
	for (i = 0; i < row;  i++)
		delete[] img[i];
	delete[] img;
}

void Deallo3Int(int ***img, int z, int row)
{
	int i,j;

	for (i = 0; i < z;  i++)
		for(j=0;j<row;j++)
			delete[] img[i][j];
	for (i = 0; i < z;  i++)
		delete[] img[i];
	delete[] img;
}

void Deallo3Short(short ***img, int z, int row)
{
	int i,j;
	for (i = 0; i < z;  i++)
		for(j=0;j<row;j++)
			delete[] img[i][j];
	for (i = 0; i < z;  i++)
		delete[] img[i];
	delete[] img;
}

void Deallo3UC(unsigned char ***img, int z, int row)
{
	int i,j;
	for (i = 0; i < z;  i++)
		for(j=0;j<row;j++)
			delete[] img[i][j];
	for (i = 0; i < z;  i++)
		delete[] img[i];
	delete[] img;
}

void Deallo2RGB(UnsignedRGB **img, int row)
{
	int i;
	for (i = 0; i < row;  i++)
		delete[] img[i];
	delete[] img;
}