IplImage* face_canny;

void on_mouse_face_canny( int event, int x, int y, int flags, void* param );

double HoughTr_interactive(IplImage* img, CvPoint Hough_line[300][2], int method);

CvPoint4D32f HoughTr(IplImage* img, IplImage *Hough_img, CvPoint Hough_line[300][3], int method);

////////////////////////////////////////////////////////////////////////////////////////////

CvPoint4D32f HoughTr(IplImage* img, IplImage *Hough_img, CvPoint Hough_line[300][3], int method)
{
	using namespace cv;

	IplImage* src;
    IplImage* color_dst;
    CvMemStorage* storage = cvCreateMemStorage(0);
    CvSeq* lines = 0;
    int i, count=0, count2=0;
	double angle, length, angle_sum=0.0, length_sum=0.0, possibility;
	int line_no;
	CvSize img_size = cvGetSize(img);
	Scalar mean, stddev;
	CvPoint4D32f result;

	src = cvCreateImage( img_size, 8, 1 );
    face_canny = cvCreateImage(img_size, 8, 1 );
    color_dst = cvCreateImage( img_size, 8, 3 );

	cvCvtColor(img, src, CV_RGB2GRAY);
	//cvSmooth( src, src, CV_GAUSSIAN, 3, 3);
    cvCanny( src, face_canny, canny1, canny2, 3 );
	//cvInvert( face_canny, face_canny );
    cvCvtColor( face_canny, color_dst, CV_GRAY2BGR );

	if(method==0)	//Standard method. Not used here.
	{
		lines = cvHoughLines2( face_canny, storage, CV_HOUGH_STANDARD, 1, CV_PI/180, 100, 0, 0 );

		line_no = MIN(lines->total,300);

		for( i = 0; i < line_no; i++ )
		{
			float* line = (float*)cvGetSeqElem(lines,i);
			float rho = line[0];
			float theta = line[1];
			//CvPoint pt1, pt2;
			double a = cos(theta), b = sin(theta);
			double x0 = a*rho, y0 = b*rho;
			Hough_line[i][0].x = cvRound(x0 + 1000*(-b));
			Hough_line[i][0].y = cvRound(y0 + 1000*(a));
			Hough_line[i][1].x = cvRound(x0 - 1000*(-b));
			Hough_line[i][1].y = cvRound(y0 - 1000*(a));

			angle = theta*180/CV_PI;
			//if(angle > 87 && angle < 93)
			{
				cvLine( color_dst, Hough_line[i][0], Hough_line[i][1], CV_RGB(255,0,0), 1, CV_AA, 0 );
				count++;
				angle_sum+=angle;
			}
		}
	}

	else		//Probabilistic method
	{
		//lines = cvHoughLines2( face_canny, storage, CV_HOUGH_PROBABILISTIC, 1, CV_PI/180, 150, 50, 50 );
		lines = cvHoughLines2( face_canny, storage, CV_HOUGH_PROBABILISTIC, 1, CV_PI/180, 30, 10, 10 );
		line_no = MIN(lines->total,300);

		for( i = 0; i < line_no; i++ )
		{
			CvPoint* line = (CvPoint*)cvGetSeqElem(lines,i);
			Hough_line[i][0] = cvPoint(line[0].x, line[0].y);
			Hough_line[i][1] = cvPoint(line[1].x, line[1].y);
			Hough_line[i][2] = cvPoint(0.0, 0.0);

			float theta = atan( (line[1].y - line[0].y) / (double)(line[1].x - line[0].x));
			angle = theta*180/CV_PI;
			length = sqrt(((double)line[1].y - line[0].y)*(line[1].y - line[0].y) + (line[1].x - line[0].x)*(line[1].x - line[0].x));

			float temp = (Hough_line[i][1].y - (float)Hough_line[i][0].y)/(Hough_line[i][1].x - Hough_line[i][0].x)*(img_size.width/2.0 - Hough_line[i][0].x) +Hough_line[i][0].y;

			if(length< cvGetSize(img).width / 10)
				continue;

			//if(abs(angle) < 2 )
			if(abs(angle) < 2 )
			{
				cvLine( color_dst, Hough_line[i][0], Hough_line[i][1], CV_RGB(0,255,255), 2, CV_AA, 0 );
				count++;
				angle_sum+=abs(angle);
				length_sum+=length;
				Hough_line[i][2].x=1.0;
			}

			else if(abs(angle) > 88 && abs(angle) < 92)
				cvLine( color_dst, Hough_line[i][0], Hough_line[i][1], CV_RGB(255,0,255), 2, CV_AA, 0 );
			else if(abs(temp - img_size.height/2.0) < 20.0)	//if the line goes through near the image centre
				cvLine( color_dst, Hough_line[i][0], Hough_line[i][1], CV_RGB(255,255,0), 2, CV_AA, 0 );
			//else 
				//cvLine( color_dst, Hough_line[i][0], Hough_line[i][1], CV_RGB(0,255,255), 2, CV_AA, 0 );
		}

		//Calculate sdt dev of y positions of horizontal lines
		Mat pos_y(count, 1, CV_64FC1);
		count2 = 0;
		for( i = 0; i < line_no; i++ )
		{
			if(Hough_line[i][2].x == 1.0)
			{
				pos_y.at<double>(count2,0) = Hough_line[i][0].y;
				count2++;
			}
		}
		meanStdDev(pos_y, mean, stddev);


		printf("line count = %d, angle mean = %f\n", count, angle_sum/(count+0.0001));
	}

	//cvNamedWindow( "Hough", 1 );
    //cvShowImage( "Hough", color_dst );
	//cvWaitKey(0);
	//cvDestroyWindow("Hough");

	//sprintf(filename, "%sHough.png", BASE_PATH);
	//cvSaveImage(filename, color_dst );

	cvCopy( color_dst, Hough_img );

	cvReleaseImage(&src);
	cvReleaseImage(&color_dst);
	cvReleaseImage(&face_canny);

	possibility = count * (stddev[0]/face_size.height) * (length_sum/(count+0.0001)/face_size.width) / (angle_sum/(count+0.0001));
	
	if(count == 0)
	{	result.w = result.x = result.z = 0.0; result.y = -1.0;	}
	else
	{
		result.w = (float)count;
		result.x = (float)(stddev[0]/face_size.height);
		result.y = (float)(angle_sum/(count+0.0001));
		result.z = (float)(length_sum/(count+0.0001)/face_size.width);

		//printf("Er=%f Es=%f El=%f \n", result.w/(float)line_no, result.x, result.z/result.y);

	}

	return result;
}

double HoughTr_interactive(IplImage* img, CvPoint Hough_line[300][2], int method)
{
	IplImage* src;
    IplImage* color_dst;
    CvMemStorage* storage = cvCreateMemStorage(0);
    CvSeq* lines = 0;
    int i, count=0;
	double angle, length, angle_sum=0.0;
	int line_no;

	src = cvCreateImage( cvGetSize(img), 8, 1 );
    face_canny = cvCreateImage( cvGetSize(img), 8, 1 );
    color_dst = cvCreateImage( cvGetSize(img), 8, 3 );

	cvCvtColor(img, src, CV_RGB2GRAY);
    cvCanny( src, face_canny, canny1, canny2, 3 );
    cvCvtColor( face_canny, color_dst, CV_GRAY2BGR );

	printf("Erase meaningless edges. if done, press any key\n");
	cvNamedWindow( "Face_Canny", 1 );
	cvShowImage( "Face_Canny", face_canny );
	cvSetMouseCallback( "Face_Canny", on_mouse_face_canny, 0 );

	cvWaitKey(0);

	if(method==0)	//Standard method
	{
		lines = cvHoughLines2( face_canny, storage, CV_HOUGH_STANDARD, 1, CV_PI/180, 100, 0, 0 );

		line_no = MIN(lines->total,300);

		for( i = 0; i < line_no; i++ )
		{
			float* line = (float*)cvGetSeqElem(lines,i);
			float rho = line[0];
			float theta = line[1];
			//CvPoint pt1, pt2;
			double a = cos(theta), b = sin(theta);
			double x0 = a*rho, y0 = b*rho;
			Hough_line[i][0].x = cvRound(x0 + 1000*(-b));
			Hough_line[i][0].y = cvRound(y0 + 1000*(a));
			Hough_line[i][1].x = cvRound(x0 - 1000*(-b));
			Hough_line[i][1].y = cvRound(y0 - 1000*(a));

			angle = theta*180/CV_PI;
			if(angle > 87 && angle < 93)
			{
				cvLine( color_dst, Hough_line[i][0], Hough_line[i][1], CV_RGB(255,0,0), 1, CV_AA, 0 );
				count++;
				angle_sum+=angle;
			}
		}
	}

	else		//Probabilistic method
	{
		lines = cvHoughLines2( face_canny, storage, CV_HOUGH_PROBABILISTIC, 1, CV_PI/180, 50, 50, 10 );
		line_no = MIN(lines->total,300);

		for( i = 0; i < line_no; i++ )
		{
			CvPoint* line = (CvPoint*)cvGetSeqElem(lines,i);
			Hough_line[i][0] = cvPoint(line[0].x, line[0].y);
			Hough_line[i][1] = cvPoint(line[1].x, line[1].y);

			float theta = atan( (line[1].y - line[0].y) / (double)(line[1].x - line[0].x));
			angle = theta*180/CV_PI;
			length = sqrt(((double)line[1].y - line[0].y)*(line[1].y - line[0].y) + (line[1].x - line[0].x)*(line[1].x - line[0].x));

			if(abs(angle) < 1 & length> cvGetSize(img).width / 10)
			{
				cvLine( color_dst, Hough_line[i][0], Hough_line[i][1], CV_RGB(255,0,0), 1, CV_AA, 0 );
				count++;
				angle_sum+=angle;
			}

			else if(abs(angle) > 87 && abs(angle) < 93)
				cvLine( color_dst, Hough_line[i][0], Hough_line[i][1], CV_RGB(0,255,0), 1, CV_AA, 0 );
		}

		printf("line count = %d, angle mean = %f\n", count, angle_sum/count);
	}
	

    cvNamedWindow( "Source", 1 );
    cvShowImage( "Source", src );

    cvNamedWindow( "Hough", 1 );
    cvShowImage( "Hough", color_dst );

	cvWaitKey(0);
	
	cvReleaseImage(&src);
	cvReleaseImage(&color_dst);
	cvReleaseImage(&face_canny);

	if(count ==0)
		return -1;
	else
		return (angle_sum/count);
}

void on_mouse_face_canny( int event, int x, int y, int flags, void* param )
{
	CvPoint prev_pt = cvPoint(-1,-1);

	if(!face_canny)
		return;

	if( event == CV_EVENT_LBUTTONUP || !(flags & CV_EVENT_FLAG_LBUTTON) )
		prev_pt = cvPoint(-1,-1);
	else if( event == CV_EVENT_LBUTTONDOWN )
		prev_pt = cvPoint(x,y);
	else if( event == CV_EVENT_MOUSEMOVE && (flags & CV_EVENT_FLAG_LBUTTON) )
	{
		CvPoint pt = cvPoint(x,y);
		if( prev_pt.x < 0 )
			prev_pt = pt;
		cvLine( face_canny, prev_pt, pt, cvScalarAll(0), 50, 8, 0 );
		prev_pt = pt;
		cvShowImage( "Face_Canny", face_canny );
	}

}
