typedef struct CvPoint3D
{
	int x;
	int y;
	int z;
}
CvPoint3D;

typedef struct CvPoint4D32f
{
	float w;
	float x;
	float y;
	float z;
}
CvPoint4D32f;


IplImage	*org_image_t = 0, *org_image_b = 0, *org_disparity = 0, *org_canny=0, *org_markers=0;
IplImage	*img_t = 0, *img_b = 0, *img_cube = 0, *seg_cube = 0, *img_disp_cube = 0, *segment = 0, *img_disparity = 0, *img_canny = 0;

CvMat		*disparity;
IplImage	*cube_face[6], *Hough_face[6], *img_disp_face[6], *seg_face[6], *normal_face[6];
IplImage	*kinect_depth_face[6], *kinect_normal_face[6];	// for Kinect depth generation
CvMat		*disp_face[6], *persp_depth_face[6];


IplImage	*marker;
//CvPoint3D	*marker_index;

IplImage	*marker_mask = 0, *markers =0, *marker_mask_cube =0, *markers_cube =0 ;

CvPoint		curr_pt = {-1,-1};
CvPoint		prev_pt = cvPoint(-1,-1);

int			resize_ratio = 1;

CvScalar	line_color = cvScalar(255,0,0,0);
int			line_on = 0;		//draw straight line mode on/off
int			direction_on =0;	//assign x,y,z plane mode
int			region_counter = 0;

int			region_index[255];	//0:void 1:region 2:line
CvPoint		line_markers_cube[255][2], line_markers[255][2];
CvPoint3D32f	line_markers_point[255][2];
int			*valid_region;		//0:non-valid 1:valid
float		**region_info;		//[0]: validity [1]:mode [2]:planeposition [3]-[6]:min1,max1,min2,max2 [7]-[9]: region centre position ([10]-[13] Plane equation)
float		**plane_eqs;		//Plane equation [a, d, c, d]

int			square_count = 0;
CvPoint		*buf = (CvPoint*)calloc( 4, sizeof(CvPoint));

CvSize		org_size, img_size, cube_size, face_size;
CvSize2D32f	pixel_size;	//pixel size in radian

CvPoint3D32f	room_min, room_max;		// Room boundary

int			total_v=0, new_total_v=0, total_color = 0, total_uv=0, total_f=0, new_total_f=0;
int			max_vertice, max_face, new_max_vertice, new_max_face;

CvPoint*		v_2D;
CvPoint3D32f	*vertex, *new_vertex;
CvPoint3D32f	*color, *new_color;		//color per vetex for OFF format
uchar			*alpha, *new_alpha;
CvPoint2D32f	*uv, *new_uv;			//uv coordinate for obj texture
CvMat			*face, *new_face;		// triangle information [v1, v2, v3, uv1, uv2, uv3]
bool			*valid_face, *new_valid_face;

double		unit_h, unit_w;	//angular size of 1 pixel

char		filename[200];
char		out_filename[200];
int			saving_count = 0;