#pragma once

void save_obj_rect_object(CvPoint3D32f* vertex, int obj_list[MAX_OBJECTS][4], int no_object, CvMat* rectangle, int* valid_face, int total_v, int total_f)
{
	FILE	*f;
	char object_name[256];
	int i;
	int num_face = 0;
	int no_obj = 0;

	if ((fopen_s(&f, (BASE_PATH + OUTPUT_PREFIXE + ".obj").c_str(), "w")) != 0)
	{
		cout << "Could not open the obj file to write" << endl;
		exit(0);
	}


	for (i = 0; i<total_f; i++)
	{
		if (valid_face[i] != 0)
			num_face++;
	}


	fprintf(f, "# number of vertexes: %d, number of rectangles: %d\n#\n", total_v, total_f);
	fprintf(f, "###################\n#\n#vertex with (x,y,z) coordinates\n\n");

	for (i = 0; i<total_v; i++)
		fprintf(f, "v %f %f %f\n", vertex[i].x, vertex[i].y, vertex[i].z);


	for (i = 0; i<total_f; i++)
	{
		if (i == obj_list[no_obj][2] && obj_list[no_obj][0] == 5)
		{
			fprintf(f, "\ng Floor_1\n", object_name);
			fprintf(f, "f %d %d %d %d\n", (int)cvGetReal2D(rectangle, i, 0) + 1, (int)cvGetReal2D(rectangle, i, 1) + 1,
				(int)cvGetReal2D(rectangle, i, 2) + 1, (int)cvGetReal2D(rectangle, i, 3) + 1);
			i++;

			fprintf(f, "\ng Ceiling_1\n", object_name);
			fprintf(f, "f %d %d %d %d\n", (int)cvGetReal2D(rectangle, i, 0) + 1, (int)cvGetReal2D(rectangle, i, 1) + 1,
				(int)cvGetReal2D(rectangle, i, 2) + 1, (int)cvGetReal2D(rectangle, i, 3) + 1);
			i++;

			fprintf(f, "\ng Wall_1\n", object_name);
			fprintf(f, "f %d %d %d %d\n", (int)cvGetReal2D(rectangle, i, 0) + 1, (int)cvGetReal2D(rectangle, i, 1) + 1,
				(int)cvGetReal2D(rectangle, i, 2) + 1, (int)cvGetReal2D(rectangle, i, 3) + 1);
			i++;

			fprintf(f, "\ng Wall_2\n", object_name);
			fprintf(f, "f %d %d %d %d\n", (int)cvGetReal2D(rectangle, i, 0) + 1, (int)cvGetReal2D(rectangle, i, 1) + 1,
				(int)cvGetReal2D(rectangle, i, 2) + 1, (int)cvGetReal2D(rectangle, i, 3) + 1);
			i++;

			fprintf(f, "\ng Wall_3\n", object_name);
			fprintf(f, "f %d %d %d %d\n", (int)cvGetReal2D(rectangle, i, 0) + 1, (int)cvGetReal2D(rectangle, i, 1) + 1,
				(int)cvGetReal2D(rectangle, i, 2) + 1, (int)cvGetReal2D(rectangle, i, 3) + 1);
			i++;

			fprintf(f, "\ng Wall_4\n", object_name);
			fprintf(f, "f %d %d %d %d\n", (int)cvGetReal2D(rectangle, i, 0) + 1, (int)cvGetReal2D(rectangle, i, 1) + 1,
				(int)cvGetReal2D(rectangle, i, 2) + 1, (int)cvGetReal2D(rectangle, i, 3) + 1);

			no_obj++;

			continue;

		}

		else if (i == obj_list[no_obj][2])
		{

			sprintf(object_name, "%s_%d", obj_name[obj_list[no_obj][0]].c_str(), obj_list[no_obj][1]);

			fprintf(f, "\ng %s\n", object_name);
			no_obj++;
		}


		if (valid_face[i] == 1)
			fprintf(f, "f %d %d %d %d\n", (int)cvGetReal2D(rectangle, i, 0) + 1, (int)cvGetReal2D(rectangle, i, 1) + 1,
			(int)cvGetReal2D(rectangle, i, 2) + 1, (int)cvGetReal2D(rectangle, i, 3) + 1);
	}

	fclose(f);

}


void save_obj_rect_object_colour(CvPoint3D32f* vertex, CvPoint3D32f* color, int obj_list[MAX_OBJECTS][4], int no_object, CvMat* rectangle, int* valid_face, int total_v, int total_f)
{
	FILE	*f;
	char object_name[256];
	int i;
	int num_face = 0;
	int no_obj = 0;

	if ((fopen_s(&f, (BASE_PATH + OUTPUT_PREFIXE + "-colour.obj").c_str(), "w")) != 0)
	{
		cout << "Could not open the obj file to write" << endl;
		exit(0);
	}



	for (i = 0; i<total_f; i++)
	{
		if (valid_face[i] != 0)
			num_face++;
	}

	fprintf(f, "###################\n#\n# obj file created by Hansung Kim (coolhs99@hotmail.com)\n#\n");
	fprintf(f, "# number of vertexes: %d, number of rectangles: %d\n#\n", total_v, total_f);
	fprintf(f, "###################\n#\n#vertex with (x,y,z,r,g,b) coordinates\n\n");

	for (i = 0; i<total_v; i++)
		fprintf(f, "v %f %f %f %f %f %f\n", vertex[i].x, vertex[i].y, vertex[i].z, color[i].x / 255.0, color[i].y / 255.0, color[i].z / 255.0);


	//fprintf(f, "g default\n");

	//for (i = 0; i<total_f; i++)
	//{
	//	if (valid_face[i] == 1)
	//		fprintf(f, "f %d %d %d %d\n", (int)cvGetReal2D(rectangle, i, 0) + 1, (int)cvGetReal2D(rectangle, i, 1) + 1,
	//		(int)cvGetReal2D(rectangle, i, 2) + 1, (int)cvGetReal2D(rectangle, i, 3) + 1);
	//}

	for (i = 0; i<total_f; i++)
	{
		if (i == obj_list[no_obj][2] && obj_list[no_obj][0] == 5)
		{
			fprintf(f, "\ng Floor_1\n", object_name);
			fprintf(f, "f %d %d %d %d\n", (int)cvGetReal2D(rectangle, i, 0) + 1, (int)cvGetReal2D(rectangle, i, 1) + 1,
				(int)cvGetReal2D(rectangle, i, 2) + 1, (int)cvGetReal2D(rectangle, i, 3) + 1);
			i++;

			fprintf(f, "\ng Ceiling_1\n", object_name);
			fprintf(f, "f %d %d %d %d\n", (int)cvGetReal2D(rectangle, i, 0) + 1, (int)cvGetReal2D(rectangle, i, 1) + 1,
				(int)cvGetReal2D(rectangle, i, 2) + 1, (int)cvGetReal2D(rectangle, i, 3) + 1);
			i++;

			fprintf(f, "\ng Wall_1\n", object_name);
			fprintf(f, "f %d %d %d %d\n", (int)cvGetReal2D(rectangle, i, 0) + 1, (int)cvGetReal2D(rectangle, i, 1) + 1,
				(int)cvGetReal2D(rectangle, i, 2) + 1, (int)cvGetReal2D(rectangle, i, 3) + 1);
			i++;

			fprintf(f, "\ng Wall_2\n", object_name);
			fprintf(f, "f %d %d %d %d\n", (int)cvGetReal2D(rectangle, i, 0) + 1, (int)cvGetReal2D(rectangle, i, 1) + 1,
				(int)cvGetReal2D(rectangle, i, 2) + 1, (int)cvGetReal2D(rectangle, i, 3) + 1);
			i++;

			fprintf(f, "\ng Wall_3\n", object_name);
			fprintf(f, "f %d %d %d %d\n", (int)cvGetReal2D(rectangle, i, 0) + 1, (int)cvGetReal2D(rectangle, i, 1) + 1,
				(int)cvGetReal2D(rectangle, i, 2) + 1, (int)cvGetReal2D(rectangle, i, 3) + 1);
			i++;

			fprintf(f, "\ng Wall_4\n", object_name);
			fprintf(f, "f %d %d %d %d\n", (int)cvGetReal2D(rectangle, i, 0) + 1, (int)cvGetReal2D(rectangle, i, 1) + 1,
				(int)cvGetReal2D(rectangle, i, 2) + 1, (int)cvGetReal2D(rectangle, i, 3) + 1);

			no_obj++;

			continue;

		}

		else if (i == obj_list[no_obj][2])
		{

			sprintf(object_name, "%s_%d", obj_name[obj_list[no_obj][0]].c_str(), obj_list[no_obj][1]);

			fprintf(f, "\ng %s\n", object_name);
			no_obj++;
		}


		if (valid_face[i] == 1)
			fprintf(f, "f %d %d %d %d\n", (int)cvGetReal2D(rectangle, i, 0) + 1, (int)cvGetReal2D(rectangle, i, 1) + 1,
			(int)cvGetReal2D(rectangle, i, 2) + 1, (int)cvGetReal2D(rectangle, i, 3) + 1);
	}




	fclose(f);

}


void save_obj_rect(CvPoint3D32f* vertex, CvPoint2D32f* uv, CvMat* rectangle, int* valid_face, int total_v, int total_f)
{
	FILE	*f;
	char filename[512];
	int i;
	int num_face = 0;


	if ((fopen_s(&f, (BASE_PATH + OUTPUT_PREFIXE + "-texure.obj").c_str(), "w")) != 0)
	{
		cout << "Could not open the obj file to write" << endl;
		exit(0);
	}


	for (i = 0; i<total_f; i++)
	{
		if (valid_face[i] != 0)
			num_face++;
	}

	fprintf(f, "###################\n#\n# obj file created by Hansung Kim (coolhs99@hotmail.com)\n#\n");
	fprintf(f, "# number of vertexes: %d, number of rectangles: %d\n#\n", total_v, total_f);
	fprintf(f, "###################\n#\n#vertex with (x,y,z) coordinates, texture with (u,v) coordinates\n\n");

	fprintf(f, "mtllib %s-rect.obj.mtl\n", OUTPUT_PREFIXE.c_str());
	fprintf(f, "g default\n");

	for (i = 0; i<total_v; i++)
		fprintf(f, "v %f %f %f\n", vertex[i].x, vertex[i].y, vertex[i].z);
	for (i = 0; i<total_v; i++)
		fprintf(f, "vt %f %f\n", uv[i].x, uv[i].y);

	fprintf(f, "vt %f %f\n", 0.001, 0.001);		//for grey color at left bottom corner for invisible regions


	fprintf(f, "\n\n#face with vertex indexes\n\n");
	fprintf(f, "s off\n");
	fprintf(f, "g Mesh\n");
	fprintf(f, "usemtl lambert2SG\n");

	for (i = 0; i<total_f; i++)
	{
		if (valid_face[i] == 1)
			fprintf(f, "f %d/%d %d/%d %d/%d %d/%d\n", (int)cvGetReal2D(rectangle, i, 0) + 1, (int)cvGetReal2D(rectangle, i, 0) + 1,
			(int)cvGetReal2D(rectangle, i, 1) + 1, (int)cvGetReal2D(rectangle, i, 1) + 1,
				(int)cvGetReal2D(rectangle, i, 2) + 1, (int)cvGetReal2D(rectangle, i, 2) + 1,
				(int)cvGetReal2D(rectangle, i, 3) + 1, (int)cvGetReal2D(rectangle, i, 3) + 1);

		else if (valid_face[i] == 2) //invisible region
			fprintf(f, "f %d/%d %d/%d %d/%d\n", (int)cvGetReal2D(rectangle, i, 0) + 1, total_v + 1,
			(int)cvGetReal2D(rectangle, i, 1) + 1, total_v + 1,
				(int)cvGetReal2D(rectangle, i, 2) + 1, total_v + 1,
				(int)cvGetReal2D(rectangle, i, 3) + 1, total_v + 1);
	}

	fprintf(f, "\n\n#end of obj file");

	fclose(f);

	//Write mtl file

	if ((fopen_s(&f, (BASE_PATH + OUTPUT_PREFIXE + "-rect.obj.mtl").c_str(), "w")) != 0)
	{
		cout << "Could not open the mtl file to write" << endl;
		exit(0);
	}



	fprintf(f, "newmtl lambert2SG\n");
	fprintf(f, "Kd 0.00 0.00 0.00\n");
	fprintf(f, "Ka 0.00 0.00 0.00\n");
	fprintf(f, "Tf 1.00 1.00 1.00\n");
	fprintf(f, "map_Kd %s\n", TOP_IMAGE_NAME.c_str());
	fprintf(f, "Ni 1.00\n");

	fclose(f);

}


void save_off_rect_object(CvPoint3D32f* vertex, CvPoint3D32f* color, uchar *alpha, CvMat* rectangle, int* valid_face, int total_v, int total_f)
{
	FILE	*f;
	char filename[512];
	int i;
	int num_face = 0;


	if ((fopen_s(&f, (BASE_PATH + OUTPUT_PREFIXE + "-colour.off").c_str(), "w")) != 0)
	{
		cout << "Could not open the obj file to write" << endl;
		exit(0);
	}


	for (i = 0; i<total_f; i++)
	{
		if (valid_face[i] == 1)
			num_face++;
	}

	fprintf(f, "###################\n#\n# off file created by Hansung Kim (coolhs99@hotmail.com)\n#\n");
	fprintf(f, "###################\n#\n#(x,y,z,r,g,b,a) coordinates\n\n");
	fprintf(f, "COFF\n");
	fprintf(f, "%d %d 0\n", total_v, num_face);

	for (i = 0; i<total_v; i++)
		fprintf(f, "%f %f %f %d %d %d %d\n", vertex[i].x, vertex[i].y, vertex[i].z, (int)color[i].x, (int)color[i].y, (int)color[i].z, (int)alpha[i]);

	fprintf(f, "\n\n#face with vertex indexes \n\n");
	for (i = 0; i<total_f; i++)
	{
		if (valid_face[i] == 1)
			fprintf(f, "4 %d %d %d %d\n", (int)cvGetReal2D(rectangle, i, 0), (int)cvGetReal2D(rectangle, i, 1), (int)cvGetReal2D(rectangle, i, 2), (int)cvGetReal2D(rectangle, i, 3));
	}

	fprintf(f, "\n\n#end of off file");

	fclose(f);

}