#pragma once
#define MAX_VERTEX	1000000
#define OBJ_CLASS_NUMBER	15
#define MAX_OBJECTS	100

float		disp_offset = -120;
int			max_radius = 15;
int			inf_border = 160;		// data crop for top and bottom (in pixel)

bool		REMOVE_OVERAPPING_FACES = 1;	//0: No  1: Yes  Remove planes included in other bigger planes (ex. bottom and back of sofa)

int			OBJ_SAVE;
int max_vertice;
int num_cube;
float baseline;
int disp_ch;	// 1 = gery scale map 3 = colour scale map
float		disp_scale;

string BASE_PATH;
string TOP_IMAGE_NAME;
string DISP_IMAGE_NAME;
string CUBOID_INFO_NAME;
string OUTPUT_PREFIXE;


CvPoint3D32f	room_min, room_max;		// Room boundary

int no_object = 0;
Mat img_t;
Size img_size;


float	**cube_info;	//[0]type (0:Invalid 1:Cuboid 2:Room bounding box) [1]Min x [2]Max_x [3]Min y [4]max y [5]min z [6] max z [7] object index [8]Material index
float	**new_region;	//Manually added region info (obj_label, top_x, top_y, bottom_x, bottom_y) 
float	*new_cube_info;

int		**cube_valid_face;
float	*cube_volume;

CvPoint2D32f *v_2D;
CvPoint3D32f *vertex;
int				new_max_vertice, new_max_face;
CvPoint3D32f	*new_vertex;
int				*vertex_visibility;
CvPoint3D32f	*new_color;		//color per vetex for OFF format
uchar			*new_alpha;
CvPoint2D32f	*new_uv;			//uv coordinate for obj texture
CvMat			*new_face;		// triangle information [v1, v2, v3, uv1, uv2, uv3]
CvMat			*new_rectangle;		// rectagle information [v1, v2, v3, v4, uv1, uv2, uv3, uv4] when TRIANGLE == 0
int				*new_valid_face;

int				new_total_v = 0, new_total_f = 0;

int			obj_color_table[15][3] = { { 0, 0, 0 },			//0  none
													{ 128, 0, 0 },		//1  bed
													{ 0, 128, 0 },		//2  books
													{ 128, 128, 0 },		//3  ceiling
													{ 0, 0, 128 },		//4  chair
													{ 128, 0, 128 },		//5  floor
													{ 0, 128, 128 },		//6  furniture
													{ 128, 128, 128 },	//7  objects
													{ 255, 128, 128 },	//8  picture
													{ 128, 255, 128 },	//9  sofa
													{ 255, 255, 128 },	//10  table
													{ 128, 128, 255 },	//11  tv
													{ 128, 255, 255 },	//12  wall
													{ 255, 255, 255 },  //13  window
													{ 255, 128, 255 } };	//14  speaker

// "Unknown" is moved to "None", and 12 is now being used for "Speaker"
const string obj_name[15] = { "None", "Bed", "Books", "Ceiling", "Chair", "Floor", "Furniture", "Objects", "Picture", "Sofa", "Table", "TV", "Wall", "Window", "Speaker"};

const string mat_name[12] = { "None", "Wood", "Painted", "Paper", "Glass", "Brick", "Metal", "Flat", "Plastic", "Textured", "Glossy", "Shiny" };

int			obj_counter[OBJ_CLASS_NUMBER];	//used to the object numbers for the same object		
int			obj_list[MAX_OBJECTS][4];	//{obj_index, object_number, start_rect_number, end_rect_number}
int			mat_list[MAX_OBJECTS][12];	//{obj_index, On/Off Switch for "Wood", "Painted", "Paper", "Glass", "Brick", "Metal", "Flat", "Plastic", "Textured", "Glossy", "Shiny"}

char JSON_buffer[16384];
unsigned int JSON_buflen = 16384;