#pragma once

bool leftDown = false, leftup = false;
Point cor1, cor2;
Rect box;
Mat temp_img, temp_index, temp_index_colour;
int line_thickness = 10;

int assigned_label;
int rect_counter;

CvScalar	line_color = cvScalar(255, 0, 0, 0);
int			line_on = 0;		//drawing option 0: merge regions 1: drawing 2: rectangle
int			ob_index = 0;	//object index
int			region_counter = 0;


void mouseHandler(int event, int x, int y, int flags, void* param)
{

	if (line_on == 0) // Assign label to the region
	{
		if (event == EVENT_LBUTTONDOWN)
		{
			cor1.x = x;
			cor1.y = y;

			floodFill(temp_index, cor1, Scalar(ob_index));
			floodFill(temp_index_colour, cor1, Scalar(obj_color_table[ob_index][2], obj_color_table[ob_index][1], obj_color_table[ob_index][0]));

			imshow("Org", temp_img);
			imshow("Index Colour", temp_index_colour);

		}

	}

	else if (line_on == 1) // Free drawing
	{
		if (event == EVENT_LBUTTONDOWN)
		{
			leftDown = true;
			cor1.x = x;
			cor1.y = y;

			circle(temp_img, cor1, 1.0, Scalar(obj_color_table[ob_index][2], obj_color_table[ob_index][1], obj_color_table[ob_index][0]), line_thickness);
			circle(temp_index, cor1, 1.0, Scalar(ob_index), line_thickness);
			circle(temp_index_colour, cor1, 1.0, Scalar(obj_color_table[ob_index][2], obj_color_table[ob_index][1], obj_color_table[ob_index][0]), line_thickness);

			imshow("Org", temp_img);
			imshow("Index Colour", temp_index_colour);

		}

		if (event == EVENT_LBUTTONUP)
		{
			leftup = true;
			cor2.x = x;
			cor2.y = y;
		}

		if (leftDown == true && leftup == false) //when the left button is down
		{
			leftDown = true;
			cor1.x = x;
			cor1.y = y;

			circle(temp_img, cor1, 1.0, Scalar(obj_color_table[ob_index][2], obj_color_table[ob_index][1], obj_color_table[ob_index][0]), line_thickness);
			circle(temp_index, cor1, 1.0, Scalar(ob_index), line_thickness);
			circle(temp_index_colour, cor1, 1.0, Scalar(obj_color_table[ob_index][2], obj_color_table[ob_index][1], obj_color_table[ob_index][0]), line_thickness);

			imshow("Org", temp_img);
			imshow("Index Colour", temp_index_colour);
		}

		if (leftDown == true && leftup == true) //when the the button is released : reset
		{
			leftDown = false;
			leftup = false;
		}

	}

	else if (line_on == 2) // set rectangle with object labels
	{
		if (event == EVENT_LBUTTONDOWN)
		{
			leftDown = true;
			cor1.x = x;
			cor1.y = y;
		}
		if (event == EVENT_LBUTTONUP)
		{
			if (abs(x - cor1.x) > 5 && abs(y - cor1.y) > 5) //checking whether the region is too small
			{
				leftup = true;
				cor2.x = x;
				cor2.y = y;
			}
			else
			{
				cout << "Select a region more than 5 pixels" << endl;
			}
		}

		if (leftDown == true && leftup == false) //when the left button is down
		{
			Point pt;
			pt.x = x;
			pt.y = y;
			Mat temp_img2 = temp_img.clone();
			rectangle(temp_img2, cor1, pt, Scalar(obj_color_table[ob_index][2], obj_color_table[ob_index][1], obj_color_table[ob_index][0])); //drawing a rectangle continuously
			imshow("Org", temp_img2);

		}
		if (leftDown == true && leftup == true) //when the selection is done
		{

			box.width = abs(cor1.x - cor2.x);
			box.height = abs(cor1.y - cor2.y);
			box.x = min(cor1.x, cor2.x);
			box.y = min(cor1.y, cor2.y);
			rectangle(temp_img, cor1, cor2, Scalar(obj_color_table[ob_index][2], obj_color_table[ob_index][1], obj_color_table[ob_index][0]));
			rectangle(temp_index, cor1, cor2, Scalar(ob_index), CV_FILLED);
			rectangle(temp_index_colour, cor1, cor2, Scalar(obj_color_table[ob_index][2], obj_color_table[ob_index][1], obj_color_table[ob_index][0]), CV_FILLED);

			imshow("Org", temp_img);
			imshow("Index Colour", temp_index_colour);

			leftDown = false;
			leftup = false;
		}
	}
}

void manual_index_processing(Mat& img, Mat& index, Mat& index_colour)
{
	temp_img = img.clone();
	temp_index = index.clone();
	temp_index_colour = index_colour.clone();

	printf("Assign object labels \n"
		"\t ESC - break and exit\n"
		"\t SPACE - Done, move to next step\n"
		"\t o - restore original image\n"
		"\t h - help. Show the lable list\n"
		"\t a - Add a rectangle\n"
		"\t s - Free drawing\n"
		"\t d - assign label to the region\n"
		"\t + - Increase line thickness\n"
		"\t - - Decrease line thickness\n"
		"\t 1 - bed\n"
		"\t 2 - books\n"
		"\t 3 - ceiling\n"
		"\t 4 - chair\n"
		"\t 5 - floor\n"
		"\t 6 - furnture\n"
		"\t 7 - object\n"
		"\t 8 - picure\n"
		"\t 9 - sofa\n"
		"\t 0 - table\n"
		"\t q - TV\n"
		"\t w - wall\n"
		"\t e - window\n"
		"\t r - speaker\n"
		"\t x - void object (unknown)\n"
	);

	namedWindow("Index Colour", WINDOW_AUTOSIZE);
	moveWindow("Index Colour", 500, 500);
	imshow("Index Colour", temp_index_colour);

	namedWindow("Org", WINDOW_AUTOSIZE);
	moveWindow("Org", 0, 0);
	imshow("Org", temp_img);

	cvSetMouseCallback("Org", mouseHandler, 0);

	for (;;)
	{
		int c = cvWaitKey(0);

		if ((char)c == ' ')	break;

		if ((char)c == 27)
		{
			exit(-1);
		}

		if ((char)c == 'o')
		{
			line_color = cvScalar(255, 0, 0, 0);
			temp_img = img.clone();
			temp_index = index.clone();
			temp_index_colour = index_colour.clone();
			assigned_label = 0;
			rect_counter = 0;
			imshow("Org", temp_img);
			imshow("Index Colour", temp_index_colour);
		}

		if ((char)c == 'd')
		{
			printf("Assigning to the region\n");
			line_color = cvScalar(255, 0, 0, 0);
			line_on = 0;
		}

		if ((char)c == 's')
		{
			printf("Drawing\n");
			line_on = 1;
		}

		if ((char)c == 'a')
		{
			printf("Adding Rectangle\n");
			line_color = cvScalar(0, 0, 255, 0);
			line_on = 2;
		}

		if ((char)c == '+')
		{
			line_thickness += 5;
			printf("Kine Thickness = %d\n", line_thickness);
		}

		if ((char)c == '-')
		{
			line_thickness -= 5;
			printf("Kine Thickness = %d\n", line_thickness);
		}

		if ((char)c == '1')
		{
			printf("1 - bed\n");
			ob_index = 1;
		}
		if ((char)c == '2')
		{
			printf("2 - books\n");
			ob_index = 2;
		}
		if ((char)c == '3')
		{
			printf("3 - ceiling\n");
			ob_index = 3;
		}
		if ((char)c == '4')
		{
			printf("4 - chair\n");
			ob_index = 4;
		}
		if ((char)c == '5')
		{
			printf("5 - floor\n");
			ob_index = 5;
		}
		if ((char)c == '6')
		{
			printf("6 - furnture\n");
			ob_index = 6;
		}
		if ((char)c == '7')
		{
			printf("7 - object\n");
			ob_index = 7;
		}
		if ((char)c == '8')
		{
			printf("8 - picure\n");
			ob_index = 8;
		}
		if ((char)c == '9')
		{
			printf("9 - sofa\n");
			ob_index = 9;
		}
		if ((char)c == '0')
		{
			printf("10 - table\n");
			ob_index = 10;
		}
		if ((char)c == 'q')
		{
			printf("11 - TV\n");
			ob_index = 11;
		}
		if ((char)c == 'w')
		{
			printf("12 - wall\n");
			ob_index = 12;
		}
		if ((char)c == 'e')
		{
			printf("13 - window\n");
			ob_index = 13;
		}
		if ((char)c == 'r')
		{
			printf("14 - speaker\n");
			ob_index = 14;
		}

		if ((char)c == 'x')
		{
			printf("cancel - void object\n");
			ob_index = 0;
		}
		if ((char)c == 'h')
		{
			printf("Hot keys: \n"
				"\t ESC - break and exit\n"
				"\t SPACE - Done, move to next step\n"
				"\t o - restore original image\n"
				"\t h - help. Show the lable list\n"
				"\t a - Add a rectangle\n"
				"\t s - Free drawing\n"
				"\t d - assign label to the region\n"
				"\t + - Increase line thickness\n"
				"\t - - Decrease line thickness\n"
				"\t 1 - bed\n"
				"\t 2 - books\n"
				"\t 3 - ceiling\n"
				"\t 4 - chair\n"
				"\t 5 - floor\n"
				"\t 6 - furnture\n"
				"\t 7 - object\n"
				"\t 8 - picure\n"
				"\t 9 - sofa\n"
				"\t 0 - table\n"
				"\t q - TV\n"
				"\t w - wall\n"
				"\t e - window\n"
				"\t r - speaker\n"
				"\t x - void object (unknown)\n"
			);
		}

	}

	img = temp_img.clone();
	index = temp_index.clone();
	index_colour = temp_index_colour.clone();

	destroyWindow("Index Colour");
	destroyWindow("Org");

}
