
void index2indexColour(Mat& obj_index, Mat& obj_index_colour)
{
	for (int y = 0; y<obj_index_colour.rows; y++)
	{
		for (int x = 0; x<obj_index_colour.cols; x++)
		{
			int index = obj_index.at<uchar>(Point(x, y));

			Vec3b colour(obj_color_table[index][2], obj_color_table[index][1], obj_color_table[index][0]);  //BGR

			obj_index_colour.at<Vec3b>(Point(x, y)) = colour;
		}
	}

}

void obj_index_post_processing(Mat& obj_index)
{
	for (int y = 0; y < obj_index_colour.rows; y++)
	{
		for (int x = 0; x < obj_index_colour.cols; x++)
		{
			int index = obj_index.at<uchar>(Point(x, y));

			if (index == 8 )	// change picture to wall
				obj_index.at<uchar>(Point(x, y)) = 12;
			if (index == 13)	// change window to nothing
				obj_index.at<uchar>(Point(x, y)) = 0;

			//if (index == 8)	// change picture to wall
				
		}
	}
}

int region_indexing(Mat& segment, Mat& marker)
{
	//uchar		*curr, *prev;
	Scalar	new_val(0, 0, 0, 0);
	Point		pt;
	int			temp1 = 0, temp2 = 0, temp3 = 0, temp4 = 0;
	int			initial_index =  50;		//Start from 50 to avoid clash against original index values
	int			region_index = initial_index; //Start from 50 to avoid clash against original index values

	Size size = segment.size();
	Mat temp_seg;
	temp_seg = segment.clone();

	for (int y = 0; y<size.height; y++)
		for (int x = 0; x<size.width; x++)
		{
			if (temp_seg.at<uchar>(Point(x, y)) < initial_index)  //not filled yet
			{
				region_index++;
				floodFill(temp_seg, Point(x, y), Scalar(region_index));
			}
		}
		
	int region_counter = 0;
	int hist[1000];
	for (int i = 0; i < 1000; i++)
		hist[i] = 0;

	for (int y = 0; y<size.height; y++)
		for (int x = 0; x<size.width; x++)
			hist[temp_seg.at<uchar>(Point(x, y))]++;

	for (int i = initial_index; i < 1000; i++)
	{
		if (hist[i] < min_region_size)
			continue;

		region_counter++;
		for (int y = 0; y<size.height; y++)
			for (int x = 0; x < size.width; x++)
			{
				if (temp_seg.at<uchar>(Point(x, y)) == i)
					marker.at<int>(Point(x, y)) = region_counter;
			}
	}
	
	return region_counter;
}

void region_object_indexing(Mat& obj_index, Mat& region, Mat& region_info, int region_no)
{
	int elem, obj_id;
	bool temp_flag;
	Size size = obj_index.size();


	for (int l = 1; l <= region_no; l++)
	{
		temp_flag = 0;
		for (int i = 0; i<size.height; i += 10)
		{
			if (temp_flag == 1)
				break;

			for (int j = 0; j<size.width; j += 10)
			{
				elem = region.at<int>(i,j);

				if (elem == l)
				{
					obj_id = obj_index.at<uchar>(i, j);
					if(obj_id == 0)
						region_info.at<int>(l, 0) = 0;
					else
						region_info.at<int>(l, 0) = 1;
					region_info.at<int>(l, 2) = obj_id;

					if (obj_id == 3 || obj_id == 5 || obj_id == 12)
						region_info.at<int>(l, 1) = 2;			//layout bounding box
					else
						region_info.at<int>(l, 1) = 1;			//object cuboid

					temp_flag = 1;
					break;
				}
			}
		}
	}
	 
}
