#pragma once

//Parameters

#define PI 3.141592
#define MAX_OBJECTS	200
#define OBJ_CLASS_NUMBER	15

string BASE_PATH;
string TOP_IMAGE("shifted_t.png");
string BOTTOM_IMAGE("shifted_b.png");
string DISP_IMAGE("shifted-disparity.png");
string OBJ_INDEX_NAME("13_obj_index.png");
string OBJ_INDEX_NAME_NEW("13_obj_index_new.png");
string OUTPUT_PREFIXE;
string OUTPUT_NAME;

int			UI_flag;
float		baseline;			//Spheron laptop width
//float		baseline = 0.27;			//Spheron laptop width
//float		baseline = 0.11;			//RICOH mini tripod
//float		baseline = 0.211;			//for receiption scene
float		disp_scale;
float		disp_offset = -120;

int			OBJ_SAVE = 0;				//for plane 0: obj file, 1: off file 2: off vertex only
										//for cuboids 0: OBJ with JASON  1: OBJ with obj colours and JASON  2: OBJ with texture 3: OFF with obj colours

int			min_region_size = 3000;		//minimum region size for labelling
int			max_radius = 30;
float		cube_resolusion = 0.01;
float		initial_room_dim_min = -20.0;
float		initial_room_dim_max = 20.0;

int			inf_border = 160;		// Range (in pixel) from the pole to exclude from point cloud generation 

float		point_outlier_Th = 1.28;	// Threshold for normal distribution. Use only 80% - 1.28 , 90& - 1.64, 95& - 1.96


int	obj_color_table[15][3] = { { 0, 0, 0 },		//0  none    (in RGB)
							{ 128, 0, 0 },		//1  bed
							{ 0, 128, 0 },		//2  books
							{ 128, 128, 0 },	//3  ceiling
							{ 0, 0, 128 },		//4  chair
							{ 128, 0, 128 },	//5  floor
							{ 0, 128, 128 },	//6  furniture
							{ 128, 128, 128 },	//7  objects
							{ 255, 128, 128 },	//8  picture
							{ 128, 255, 128 },	//9  sofa
							{ 255, 255, 128 },	//10  table
							{ 128, 128, 255 },	//11  tv
							{ 128, 255, 255 },	//12  wall
							{ 255, 255, 255 },  //13  window
							{ 255, 128, 255 } };	//14  speaker

const string obj_name[15] = { "None", "Bed", "Books", "Ceiling", "Chair", "Floor", "Furniture", "Objects", "Picture", "Sofa", "Table", "TV", "Wall", "Window", "Speaker" };
const string mat_name[12] = { "None", "Wood", "Painted", "Paper", "Glass", "Brick", "Metal", "Flat", "Plastic", "Textured", "Glossy", "Shiny" };

int			obj_counter[OBJ_CLASS_NUMBER];	//used to the object numbers for the same object		
int			obj_list[MAX_OBJECTS][4];	//{obj_index, object_number, start_rect_number, end_rect_number}
int			mat_list[MAX_OBJECTS][12];	//{obj_index, On/Off Switch for "Wood", "Painted", "Paper", "Glass", "Brick", "Metal", "Flat", "Plastic", "Textured", "Glossy", "Shiny"}

char JSON_buffer[16384];
unsigned int JSON_buflen = 16384;

/////////////////////////////////////////////////
/////////////////////////Variables 

Mat img_t, img_b, img_disparity;
Mat obj_index, obj_index_colour, new_obj_index, new_obj_index_colour;
Mat disparity;

int	disp_ch;		//1: grey scale disparity 3: colour scale disparity 
CvSize		img_size;
double		unit_h, unit_w;	//angular size of 1 pixel

Mat region;
Mat region_info;	//[0]: validity [1]:type (0:Invalid 1:Cuboid 2:Room layout bounding box) [2] object index [3]Material index
int max_vertice;
CvPoint2D32f *v_2D;
CvPoint3D32f *vertex;
float	**cube_info;	//[0]type (0:Invalid 1:Cuboid 2:Room bounding box) [1]Min x [2]Max_x [3]Min y [4]max y [5]min z [6] max z [7] object index [8]Material index
float	*new_cube_info;
int		**cube_valid_face;	//[0] empty [1]Min x [2]Max_x [3]Min y [4]max y [5]min z [6] max z
float	*cube_volume;

CvPoint3D32f	room_min, room_max;		// Room boundary
int num_cube;

int				new_max_vertice, new_max_face;
CvPoint3D32f	*new_vertex;
int				*vertex_visibility;
CvPoint3D32f	*new_color;		//color per vetex for OFF format
uchar			*new_alpha;
CvPoint2D32f	*new_uv;			//uv coordinate for obj texture
CvMat			*new_face;		// triangle information [v1, v2, v3, uv1, uv2, uv3]
CvMat			*new_rectangle;		// rectagle information [v1, v2, v3, v4, uv1, uv2, uv3, uv4] when TRIANGLE == 0
int				*new_valid_face;
int				new_total_v = 0, new_total_f = 0;